blob: 3918f3fe0b89258366185943a498fcc5cbc7dc38 [file] [log] [blame]
garciadeblas93c61312016-09-28 15:12:48 +02001#!/bin/bash
garciadeblas38d91ee2019-11-07 16:31:23 +01002#
3# Licensed under the Apache License, Version 2.0 (the "License");
4# you may not use this file except in compliance with the License.
5# You may obtain a copy of the License at
6#
7# http://www.apache.org/licenses/LICENSE-2.0
8#
9# Unless required by applicable law or agreed to in writing, software
10# distributed under the License is distributed on an "AS IS" BASIS,
11# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
12# See the License for the specific language governing permissions and
13# limitations under the License.
14#
garciadeblasd8bc5c32018-05-09 17:37:56 +020015REPOSITORY_BASE=https://osm-download.etsi.org/repository/osm/debian
garciadeblas77c4bbb2020-07-03 15:33:36 +000016RELEASE=ReleaseEIGHT
garciadeblas7bcadc52020-02-02 22:40:15 +010017REPOSITORY=stable
garciadeblas77c4bbb2020-07-03 15:33:36 +000018DOCKER_TAG=8
garciadeblas93c61312016-09-28 15:12:48 +020019
garciadeblas38d91ee2019-11-07 16:31:23 +010020function usage(){
21 echo -e "usage: $0 [OPTIONS]"
22 echo -e "Install OSM from binaries or source code (by default, from binaries)"
23 echo -e " OPTIONS"
24 echo -e " -r <repo>: use specified repository name for osm packages"
25 echo -e " -R <release>: use specified release for osm binaries (deb packages, lxd images, ...)"
26 echo -e " -u <repo base>: use specified repository url for osm packages"
27 echo -e " -k <repo key>: use specified repository public key url"
28 echo -e " -b <refspec>: install OSM from source code using a specific branch (master, v2.0, ...) or tag"
29 echo -e " -b master (main dev branch)"
30 echo -e " -b v2.0 (v2.0 branch)"
31 echo -e " -b tags/v1.1.0 (a specific tag)"
32 echo -e " ..."
vijaynag4b57d462020-06-08 14:23:10 +000033 echo -e " -n <ui> install OSM with Next Gen UI. Valid values are <lwui> or <ngui>. If -n is not specified osm will be installed with light-ui. When used with uninstall, osm along with the UI specified will be uninstalled"
garciadeblas38d91ee2019-11-07 16:31:23 +010034 echo -e " -s <stack name> user defined stack name, default is osm"
35 echo -e " -H <VCA host> use specific juju host controller IP"
36 echo -e " -S <VCA secret> use VCA/juju secret key"
37 echo -e " -P <VCA pubkey> use VCA/juju public key file"
38 echo -e " -C <VCA cacert> use VCA/juju CA certificate file"
39 echo -e " -A <VCA apiproxy> use VCA/juju API proxy"
40 echo -e " --vimemu: additionally deploy the VIM emulator as a docker container"
41 echo -e " --elk_stack: additionally deploy an ELK docker stack for event logging"
magnussonl1bbe9452020-02-25 13:43:17 +010042 echo -e " --pla: install the PLA module for placement support"
garciadeblas38d91ee2019-11-07 16:31:23 +010043 echo -e " --pm_stack: additionally deploy a Prometheus+Grafana stack for performance monitoring (PM)"
magnussonl1bbe9452020-02-25 13:43:17 +010044 echo -e " -m <MODULE>: install OSM but only rebuild the specified docker images (LW-UI, NBI, LCM, RO, MON, POL, KAFKA, MONGO, PROMETHEUS, KEYSTONE-DB, PLA, NONE)"
garciadeblas38d91ee2019-11-07 16:31:23 +010045 echo -e " -o <ADDON>: ONLY (un)installs one of the addons (vimemu, elk_stack, pm_stack)"
46 echo -e " -D <devops path> use local devops installation path"
47 echo -e " -w <work dir> Location to store runtime installation"
48 echo -e " -t <docker tag> specify osm docker tag (default is latest)"
David Garcia79f4f532020-04-07 12:59:34 +020049 echo -e " -l: LXD cloud yaml file"
50 echo -e " -L: LXD credentials yaml file"
David Garcia404ae122020-04-28 11:47:55 +020051 echo -e " -K: Specifies the name of the controller to use - The controller must be already bootstrapped"
David Garcia79f4f532020-04-07 12:59:34 +020052 echo -e " --nolxd: do not install and configure LXD, allowing unattended installations (assumes LXD is already installed and confifured)"
garciadeblas38d91ee2019-11-07 16:31:23 +010053 echo -e " --nodocker: do not install docker, do not initialize a swarm (assumes docker is already installed and a swarm has been initialized)"
54 echo -e " --nojuju: do not juju, assumes already installed"
55 echo -e " --nodockerbuild:do not build docker images (use existing locally cached images)"
56 echo -e " --nohostports: do not expose docker ports to host (useful for creating multiple instances of osm on the same host)"
57 echo -e " --nohostclient: do not install the osmclient"
58 echo -e " --uninstall: uninstall OSM: remove the containers and delete NAT rules"
59 echo -e " --source: install OSM from source code using the latest stable tag"
60 echo -e " --develop: (deprecated, use '-b master') install OSM from source code using the master branch"
61 echo -e " --soui: install classic build of OSM (Rel THREE v3.1, based on LXD containers, with SO and UI)"
62 echo -e " --lxdimages: (only for Rel THREE with --soui) download lxd images from OSM repository instead of creating them from scratch"
63 echo -e " --pullimages: pull/run osm images from docker.io/opensourcemano"
64 echo -e " -l <lxd_repo>: (only for Rel THREE with --soui) use specified repository url for lxd images"
65 echo -e " -p <path>: (only for Rel THREE with --soui) use specified repository path for lxd images"
66 echo -e " --nat: (only for Rel THREE with --soui) install only NAT rules"
67 echo -e " --noconfigure: (only for Rel THREE with --soui) DO NOT install osmclient, DO NOT install NAT rules, DO NOT configure modules"
68 echo -e " --showopts: print chosen options and exit (only for debugging)"
madaviae0784f2020-01-22 16:29:19 +053069 #echo -e " --clean_volumes To clear all the mounted volumes from docker swarm"
garciadeblas38d91ee2019-11-07 16:31:23 +010070 echo -e " -y: do not prompt for confirmation, assumes yes"
71 echo -e " -h / --help: print this help"
Dominik Fleischmann7a97a4c2020-06-04 10:52:05 +020072 echo -e " --charmed: Deploy and operate OSM with Charms on k8s"
73 echo -e " [--bundle <bundle path>]: Specify with which bundle to deploy OSM with charms (--charmed option)"
74 echo -e " [--k8s <kubeconfig path>]: Specify with which kubernetes to deploy OSM with charms (--charmed option)"
75 echo -e " [--vca <name>]: Specifies the name of the controller to use - The controller must be already bootstrapped (--charmed option)"
76 echo -e " [--lxd <yaml path>]: Takes a YAML file as a parameter with the LXD Cloud information (--charmed option)"
77 echo -e " [--lxd-cred <yaml path>]: Takes a YAML file as a parameter with the LXD Credentials information (--charmed option)"
78 echo -e " [--microstack]: Installs microstack as a vim. (--charmed option)"
Dominik Fleischmannc57296f2020-06-09 11:45:08 +020079 echo -e " [--ha]: Installs High Availability bundle. (--charmed option)"
Dominik Fleischmann7a97a4c2020-06-04 10:52:05 +020080 echo -e " [--tag]: Docker image tag"
81
garciadeblas38d91ee2019-11-07 16:31:23 +010082}
83
garciadeblasd8bc5c32018-05-09 17:37:56 +020084add_repo() {
85 REPO_CHECK="^$1"
86 grep "${REPO_CHECK/\[arch=amd64\]/\\[arch=amd64\\]}" /etc/apt/sources.list > /dev/null 2>&1
87 if [ $? -ne 0 ]
88 then
garciadeblasbd925e42018-06-14 14:32:12 +020089 need_packages_lw="software-properties-common apt-transport-https"
90 echo -e "Checking required packages: $need_packages_lw"
91 dpkg -l $need_packages_lw &>/dev/null \
92 || ! echo -e "One or several required packages are not installed. Updating apt cache requires root privileges." \
93 || sudo apt-get -q update \
Mike Marchetti34124182018-10-16 08:22:30 -040094 || ! echo "failed to run apt-get update" \
garciadeblasbd925e42018-06-14 14:32:12 +020095 || exit 1
96 dpkg -l $need_packages_lw &>/dev/null \
97 || ! echo -e "Installing $need_packages_lw requires root privileges." \
98 || sudo apt-get install -y $need_packages_lw \
Mike Marchetti34124182018-10-16 08:22:30 -040099 || ! echo "failed to install $need_packages_lw" \
garciadeblasbd925e42018-06-14 14:32:12 +0200100 || exit 1
garciadeblasd8bc5c32018-05-09 17:37:56 +0200101 wget -qO - $REPOSITORY_BASE/$RELEASE/OSM%20ETSI%20Release%20Key.gpg | sudo apt-key add -
102 sudo DEBIAN_FRONTEND=noninteractive add-apt-repository -y "$1" && sudo DEBIAN_FRONTEND=noninteractive apt-get update
garciadeblas429b9f82018-03-20 02:09:44 +0100103 return 0
garciadeblasd8bc5c32018-05-09 17:37:56 +0200104 fi
105
106 return 1
garciadeblas55490d42016-10-29 14:22:03 +0200107}
108
garciadeblas25e87d22020-01-31 14:27:29 +0100109clean_old_repo() {
madaviae0784f2020-01-22 16:29:19 +0530110dpkg -s 'osm-devops' &> /dev/null
madaviae0784f2020-01-22 16:29:19 +0530111if [ $? -eq 0 ]; then
madaviae0784f2020-01-22 16:29:19 +0530112 # Clean the previous repos that might exist
113 sudo sed -i "/osm-download.etsi.org/d" /etc/apt/sources.list
114fi
115}
116
vijaynag4b57d462020-06-08 14:23:10 +0000117while getopts ":b:r:c:n:k:u:R:l:L:K:p:D:o:O:m:N:H:S:s:w:t:U:P:A:-: hy" o; do
garciadeblas38d91ee2019-11-07 16:31:23 +0100118 case "${o}" in
garciadeblas38d91ee2019-11-07 16:31:23 +0100119 r)
120 REPOSITORY="${OPTARG}"
121 ;;
122 R)
123 RELEASE="${OPTARG}"
124 ;;
125 u)
126 REPOSITORY_BASE="${OPTARG}"
127 ;;
128 t)
garciadeblas25e87d22020-01-31 14:27:29 +0100129 DOCKER_TAG="${OPTARG}"
garciadeblas38d91ee2019-11-07 16:31:23 +0100130 ;;
garciadeblas72399e32019-11-22 10:09:40 +0100131 -)
132 [ "${OPTARG}" == "help" ] && usage && exit 0
Dominik Fleischmann5e4a7512020-03-06 14:05:06 +0100133 ;;
garciadeblas25e87d22020-01-31 14:27:29 +0100134 :)
135 echo "Option -$OPTARG requires an argument" >&2
136 usage && exit 1
137 ;;
138 \?)
139 echo -e "Invalid option: '-$OPTARG'\n" >&2
140 usage && exit 1
141 ;;
142 h)
143 usage && exit 0
144 ;;
garciadeblas38d91ee2019-11-07 16:31:23 +0100145 *)
146 ;;
147 esac
148done
149
garciadeblas25e87d22020-01-31 14:27:29 +0100150clean_old_repo
garciadeblasd8bc5c32018-05-09 17:37:56 +0200151add_repo "deb [arch=amd64] $REPOSITORY_BASE/$RELEASE $REPOSITORY devops"
garciadeblas35f96ae2018-05-23 12:33:36 +0200152sudo DEBIAN_FRONTEND=noninteractive apt-get -q update
153sudo DEBIAN_FRONTEND=noninteractive apt-get install osm-devops
garciadeblasa5e66072019-05-29 12:23:22 +0200154/usr/share/osm-devops/installers/full_install_osm.sh -R $RELEASE -r $REPOSITORY -u $REPOSITORY_BASE -D /usr/share/osm-devops -t $DOCKER_TAG "$@"